﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;

namespace PC机监控软件
{
    public partial class Form1 : Form
    {
        #region 视频相关变量
        private IntPtr lwndC;       //保存无符号句柄
        private IntPtr mControlPtr; //保存管理指示器
        private int mWidth;
        private int mHeight;
        #endregion
        #region 设置视频相关函数
        /// <summary>
        /// 设置视频监控的父窗口句柄，宽和高
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="width"></param>
        /// <param name="height"></param>
        public void cVideo(IntPtr handle, int width, int height)
        {
            mControlPtr = handle; //显示视频控件的句柄
            mWidth = width;      //视频宽度
            mHeight = height;    //视频高度
        }
        /// <summary>
        /// 打开视频
        /// </summary>
        public void StartCam()
        {
            byte[] lpszName = new byte[100];
            byte[] lpszVer = new byte[100];
            //查询驱动信息
            API.capGetDriverDescriptionA(0, lpszName, 100, lpszVer, 100);
            //创建1个视频捕捉窗口
            lwndC = API.capCreateCaptureWindowA(lpszName, API.WS_CHILD | API.WS_VISIBLE, 0, 0, mWidth, mHeight, mControlPtr, 0);
            if (API.SendMessage(lwndC, API.WM_CAP_DRIVER_CONNECT, 0, 0))
            {
                API.SendMessage(lwndC, API.WM_CAP_SET_PREVIEWRATE, 100, 0);
                API.SendMessage(lwndC, API.WM_CAP_SET_PREVIEW, true, 0);
            }
        }
        /// <summary>
        /// 开始录像
        /// </summary>
        /// <param name="path">路径</param>
        public void StarKinescope(string path)
        {
            IntPtr hBmp = Marshal.StringToHGlobalAnsi(path);
            API.SendMessage(lwndC, API.WM_CAP_FILE_SET_CAPTURE_FILEA, 0, hBmp.ToInt32());
            API.SendMessage(lwndC, API.WM_CAP_SEQUENCE, 0, 0);
        }
        /// <summary>
        /// 停止录像
        /// </summary>
        public void StopKinescope()
        {
            API.SendMessage(lwndC, API.WM_CAP_STOP, 0, 0);
        }

        #endregion

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            cVideo(SCREEN.Handle, SCREEN.Width, SCREEN.Height);
            StartCam();
            WAY.Text = "D:\\视频.avi";
        }

        private void START_Click(object sender, EventArgs e)
        {
            string path;
            try
            {
                path = WAY.Text;
                if (path[path.Length - 1] == 'i' &&
                    path[path.Length - 2] == 'v' &&
                    path[path.Length - 3] == 'a'
                )
                {
                    FileStream s = new FileStream(path, FileMode.Create);
                    s.Close();
                    STATE.Text = "正在录像";
                    this.Enabled = false;
                    StarKinescope(path);
                    START.Enabled = false;
                    STOP.Enabled = true;
                    this.Enabled = true;
                }
                else
                { MessageBox.Show("错误，请检查路径是否正确，文件夹是否存在,或文件名是否正确", "错误"); }
            }
            catch
            {
                MessageBox.Show("错误，请检查路径是否正确，文件夹是否存在,或文件名是否正确", "错误");
            }
        }

        private void STOP_Click(object sender, EventArgs e)
        {
            StopKinescope();
            STATE.Text = "等待中";
            START.Enabled = true;
            STOP.Enabled = false;
        }

        private void EXIT_Click(object sender, EventArgs e)
        {
            StopKinescope();
            this.Close();
        }
    }
}
